//+------------------------------------------------------------------+
//|                                            TZZCTF-513.mq4 |
//+------------------------------------------------------------------+
#property copyright           ""
#property link                ""
#property version             "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers   1
#property indicator_type1     DRAW_SECTION
#property indicator_color1    clrNONE

#define PREFIX "TF"

#resource "\\Indicators\\ZigZag.ex4"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum ENUM_FRACTAL_TYPE
  {
   FRACTAL_UPPER,
   FRACTAL_LOWER
  };

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
input string  InpName="513-CTF" ; // Line Names
input ENUM_TIMEFRAMES ZZ_TIMEFRAME=PERIOD_CURRENT;//ZZ Timeframe
input uint  ZZ_DEPTH=5;//ZZ Depth
input uint  ZZ_DEVIATION=1;//ZZ Deviation
input uint  ZZ_BACKSTEP=3;//ZZ BackStep
input color InpResistanceColor=clrLime;//Resistance Color
input color InpSupportColor=clrMagenta;//SupportColor
input ENUM_LINE_STYLE InpResistanceStyle=STYLE_SOLID; // Resistance Line Style
input ENUM_LINE_STYLE InpSupportStyle=STYLE_SOLID; // Support Line Style
input ENUM_TIMEFRAMES TFCA=PERIOD_CURRENT ; // TF Candle Alert
input bool InpScreenAlertRange=false;//Range Screen Alert & Push Alert
input bool InpScreenAlertBuy_Sell=false;//Continue Buy/Sell Screen Alert & Push Alert
input bool InpScreenAlertBeginBS=false;//Begin BS Screen Alert & Push Alert
//input bool InpPushAlert=true;//Push Alert
//input bool InpMailAlert=false;//Email Alert
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
struct TFractal
  {
   double            price;
   datetime          time;
   int               index;

   void Clear()
     {
      price=0;
      time=0;
      index=0;
     }

  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
struct TLine
  {
   int               points;
   TFractal          begin_point;
   TFractal          end_point;

   void Clear()
     {
      begin_point.Clear();
      end_point.Clear();
      points=0;
     }

  };
//---
TLine upper_line={};
TLine lower_line={};
TLine upper_line_tf={};
TLine lower_line_tf={};
//---
datetime time_alert;
double ZZBuffer[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
   SetIndexBuffer(0,ZZBuffer);
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   int total=ObjectsTotal(0,0);
   for(int i=total-1; i>=0; i--)
     {
      string name=ObjectName(0,i);
      if(StringFind(name,PREFIX)!=-1)
         ObjectDelete(0,name);
     }

  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {

   if(prev_calculated==0)
     {
      time_alert=iTime(NULL,TFCA,1);
      ArrayInitialize(ZZBuffer,EMPTY_VALUE);
     }

   upper_line.Clear();
   lower_line.Clear();
   bool first=false;
//---
   int total=Bars(NULL,ZZ_TIMEFRAME);
   for(int i=0; i<total && !_StopFlag; i++)
     {

      //--- stop searching
      if(upper_line.points>1 &&
         lower_line.points>1 )
         break;

      //---
      double _zz=NormalizeDouble(iCustom(_Symbol,ZZ_TIMEFRAME,"::Indicators\\ZigZag.ex4",ZZ_DEPTH,ZZ_DEVIATION,ZZ_BACKSTEP,0,i),_Digits);
      if(_zz>DBL_MIN && _zz!=EMPTY_VALUE)
        {
         if(!first)
           {
            first=true;
            continue;
           }

         double _high=NormalizeDouble(iHigh(NULL,ZZ_TIMEFRAME,i),_Digits);
         double _low=NormalizeDouble(iLow(NULL,ZZ_TIMEFRAME,i),_Digits);

         if(fabs(_zz-_high)<_Point)
           {
            if(upper_line.points==0)
              {
               upper_line.begin_point.index=i;
               upper_line.begin_point.price=_high;
               upper_line.begin_point.time=iTime(NULL,ZZ_TIMEFRAME,i);
               upper_line.points++;
               continue;
              }

            if(upper_line.points==1)
              {
               upper_line.end_point.index=i;
               upper_line.end_point.price=_high;
               upper_line.end_point.time=iTime(NULL,ZZ_TIMEFRAME,i);
               upper_line.points++;
               continue;
              }
           }

         if(fabs(_zz-_low)<_Point)
           {
            if(lower_line.points==0)
              {
               lower_line.begin_point.index=i;
               lower_line.begin_point.price=_low;
               lower_line.begin_point.time=iTime(NULL,ZZ_TIMEFRAME,i);
               lower_line.points++;
               continue;
              }

            if(lower_line.points==1)
              {
               lower_line.end_point.index=i;
               lower_line.end_point.price=_low;
               lower_line.end_point.time=iTime(NULL,ZZ_TIMEFRAME,i);
               lower_line.points++;
               continue;
              }
           }
        }
     }

//--- find on M30
   upper_line_tf=upper_line;
   lower_line_tf=lower_line;
   AdjustTime(upper_line_tf.begin_point,TFCA,FRACTAL_UPPER);
   AdjustTime(upper_line_tf.end_point,TFCA,FRACTAL_UPPER);
   AdjustTime(lower_line_tf.begin_point,TFCA,FRACTAL_LOWER);
   AdjustTime(lower_line_tf.end_point,TFCA,FRACTAL_LOWER);

//--- find on Current TF
   AdjustTime(upper_line.begin_point,PERIOD_CURRENT,FRACTAL_UPPER);
   AdjustTime(upper_line.end_point,PERIOD_CURRENT,FRACTAL_UPPER);
   AdjustTime(lower_line.begin_point,PERIOD_CURRENT,FRACTAL_LOWER);
   AdjustTime(lower_line.end_point,PERIOD_CURRENT,FRACTAL_LOWER);

//--- show on curent TF
   SetTrendLine(PREFIX+InpName+"up",
                upper_line.begin_point.time,
                upper_line.begin_point.price,
                upper_line.end_point.time,
                upper_line.end_point.price,
                InpResistanceColor,InpResistanceStyle,1,InpName,InpName);

   SetTrendLine(PREFIX+InpName+"down",
                lower_line.begin_point.time,
                lower_line.begin_point.price,
                lower_line.end_point.time,
                lower_line.end_point.price,
                InpSupportColor,InpSupportStyle,1,InpName,InpName);

   SetArrow(PREFIX+InpName+"up_begin",
            upper_line.begin_point.time,
            upper_line.begin_point.price,
            ANCHOR_BOTTOM,
            115,InpResistanceColor,3);

   SetArrow(PREFIX+InpName+"up_end",
            upper_line.end_point.time,
            upper_line.end_point.price,
            ANCHOR_BOTTOM,
            115,InpResistanceColor,3);

   SetArrow(PREFIX+InpName+"down_begin",
            lower_line.begin_point.time,
            lower_line.begin_point.price,
            ANCHOR_TOP,
            115,InpSupportColor,3);

   SetArrow(PREFIX+InpName+"down_end",
            lower_line.end_point.time,
            lower_line.end_point.price,
            ANCHOR_TOP,
            115,InpSupportColor,3);

//---   
   ZZBuffer[upper_line.begin_point.index]=upper_line.begin_point.price;
   ZZBuffer[upper_line.end_point.index]=upper_line.end_point.price;
   ZZBuffer[lower_line.begin_point.index]=lower_line.begin_point.price;
   ZZBuffer[lower_line.end_point.index]=lower_line.end_point.price;


//--- find regression
   double upper_price0=0;
   int upper_delta=upper_line_tf.end_point.index-upper_line_tf.begin_point.index;
   if(upper_delta>0)
     {
      upper_price0=(upper_line_tf.end_point.price-upper_line_tf.begin_point.price)/upper_delta;
      upper_price0=NormalizeDouble(upper_line_tf.end_point.price-upper_price0*upper_line_tf.end_point.index,_Digits);
     }

   double lower_price0=0;
   int lower_delta=lower_line_tf.end_point.index-lower_line_tf.begin_point.index;
   if(lower_delta>0)
     {
      lower_price0=(lower_line_tf.end_point.price-lower_line_tf.begin_point.price)/lower_delta;
      lower_price0=NormalizeDouble(lower_line_tf.end_point.price-lower_price0*lower_line_tf.end_point.index,_Digits);
     
     }
 
//--- Alert
   MqlRates rates_tf[];
   if(ArrayCopyRates(rates_tf,NULL,TFCA)>4)
     {
     //---Range
      if(time_alert!=rates_tf[1].time && 
         rates_tf[1].close<upper_price0 &&
         rates_tf[1].close>lower_price0
         ) 
        {
         time_alert=rates_tf[1].time;
         string msg=StringFormat("%s RANGE "+InpName,_Symbol,StringSubstr(EnumToString(ZZ_TIMEFRAME),7),StringSubstr(EnumToString(TFCA),7));
         if(InpScreenAlertRange)
            Alert(msg);
         if(InpScreenAlertRange)
            SendNotification(msg);
         //if(InpMailAlert)
            //SendMail(msg,msg);
        }
        
          //--- Begin Buy
      if(time_alert!=rates_tf[1].time && 
         rates_tf[1].close>upper_price0 &&
         rates_tf[1].low<upper_price0 &&
         rates_tf[1].close>rates_tf[1].open
         ) 
        {
         time_alert=rates_tf[1].time;
         string msg=StringFormat("%s Begin BUY "+InpName,_Symbol,StringSubstr(EnumToString(ZZ_TIMEFRAME),7),StringSubstr(EnumToString(TFCA),7));
         if(InpScreenAlertBeginBS)
            Alert(msg);
         if(InpScreenAlertBeginBS)
            SendNotification(msg);
        // if(InpMailAlert)
           // SendMail(msg,msg);
        }

      //--- Buy
      if(time_alert!=rates_tf[1].time && 
         rates_tf[1].close>upper_price0 &&
         rates_tf[1].close>rates_tf[1].open
         ) 
        {
         time_alert=rates_tf[1].time;
         string msg=StringFormat("%s BUY "+InpName,_Symbol,StringSubstr(EnumToString(ZZ_TIMEFRAME),7),StringSubstr(EnumToString(TFCA),7));
         if(InpScreenAlertBuy_Sell)
            Alert(msg);
         if(InpScreenAlertBuy_Sell)
            SendNotification(msg);
        // if(InpMailAlert)
           // SendMail(msg,msg);
        }
       
        //--- Begin Sell
      if(time_alert!=rates_tf[1].time && 
         rates_tf[1].close<lower_price0 &&
         rates_tf[1].high>lower_price0 &&      
         rates_tf[1].close<rates_tf[1].open
         ) 
        {
         time_alert=rates_tf[1].time;
         string msg=StringFormat("%s Begin SELL "+InpName,_Symbol,StringSubstr(EnumToString(ZZ_TIMEFRAME),7),StringSubstr(EnumToString(TFCA),7));
         if(InpScreenAlertBeginBS)
            Alert(msg);
         if(InpScreenAlertBeginBS)
            SendNotification(msg);
         //if(InpMailAlert)
           // SendMail(msg,msg);
        }

 
//--- Sell
      if(time_alert!=rates_tf[1].time && 
         rates_tf[1].close<lower_price0 &&
         rates_tf[1].close<rates_tf[1].open
         ) 
        {
         time_alert=rates_tf[1].time;
         string msg=StringFormat("%s SELL "+InpName,_Symbol,StringSubstr(EnumToString(ZZ_TIMEFRAME),7),StringSubstr(EnumToString(TFCA),7));
         if(InpScreenAlertBuy_Sell)
            Alert(msg);
         if(InpScreenAlertBuy_Sell)
            SendNotification(msg);
         //if(InpMailAlert)
           // SendMail(msg,msg);
        }
 

     }
//---
   return(rates_total);
  }
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void AdjustTime(TFractal &fractal,
                const ENUM_TIMEFRAMES _tf,
                const ENUM_FRACTAL_TYPE _type)
  {
   int index=iBarShift(NULL,_tf,fractal.time);
   for(int i=index; i>=0; i--)
     {
      if((_type==FRACTAL_UPPER && fractal.price==iHigh(NULL,_tf,i))||
         (_type==FRACTAL_LOWER && fractal.price==iLow(NULL,_tf,i)))
        {
         fractal.time=iTime(NULL,_tf,i);
         fractal.index=i;
         break;
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetTrendLine(const string _name,
                  const datetime _time1,
                  const double _price1,
                  const datetime _time2,
                  const double _price2,
                  const color _colour,
                  const ENUM_LINE_STYLE _style=STYLE_SOLID,
                  const int _width=1,
                  const string _desc="\n",
                  const string _hint="\n")
  {
   string obj_name=_name;
   if(ObjectFind(0,obj_name)==0)
     {
      ObjectSetInteger(0,obj_name,OBJPROP_TIME1,_time2);
      ObjectSetInteger(0,obj_name,OBJPROP_TIME2,_time1);
      ObjectSetDouble(0,obj_name,OBJPROP_PRICE1,_price2);
      ObjectSetDouble(0,obj_name,OBJPROP_PRICE2,_price1);
     }
   else
     {
      if(ObjectCreate(0,obj_name,OBJ_TREND,0,_time2,_price2,_time1,_price1))
        {
         ObjectSetInteger(0,obj_name,OBJPROP_TIME1,_time2);
         ObjectSetInteger(0,obj_name,OBJPROP_TIME2,_time1);
         ObjectSetDouble(0,obj_name,OBJPROP_PRICE1,_price2);
         ObjectSetDouble(0,obj_name,OBJPROP_PRICE2,_price1);
         ObjectSetInteger(0,obj_name,OBJPROP_RAY,false);
         ObjectSetInteger(0,obj_name,OBJPROP_RAY_RIGHT,true);
         ObjectSetInteger(0,obj_name,OBJPROP_BACK,false);
         ObjectSetInteger(0,obj_name,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(0,obj_name,OBJPROP_SELECTED,false);
         ObjectSetInteger(0,obj_name,OBJPROP_WIDTH,_width);
         ObjectSetInteger(0,obj_name,OBJPROP_COLOR,_colour);
         ObjectSetInteger(0,obj_name,OBJPROP_STYLE,_style);
         ObjectSetString(0,obj_name,OBJPROP_TEXT,_desc);
         ObjectSetString(0,obj_name,OBJPROP_TOOLTIP,_hint);
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetArrow(const string name,
              const datetime time,
              const double price,
              const ENUM_ARROW_ANCHOR anchor,
              const int arrow_code=233,
              const color clr=clrLime,
              const int width=1
              )
  {
   if(ObjectFind(name)==0 || ObjectCreate(name,OBJ_ARROW,0,time,price))
     {
      ObjectSetDouble(0,name,OBJPROP_PRICE1,price);
      ObjectSetInteger(0,name,OBJPROP_TIME1,time);
      ObjectSetInteger(0,name,OBJPROP_ARROWCODE,arrow_code);
      ObjectSetInteger(0,name,OBJPROP_COLOR,clr);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,width);
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,false);
      ObjectSetInteger(0,name,OBJPROP_ANCHOR,anchor);
      ObjectSetString(0,name,OBJPROP_TOOLTIP,"\n");
     }
  }
//+------------------------------------------------------------------+
